static char netplayhost[256]={0};
static int netskip=-1;
static int netplay=0;
static int abortnetplay=0;
static HWND hwndns=0;
static int wsainit=0;
static int concommand=0;

int SetBlockingSock(SOCKET Socko)
{
   unsigned long t;
   t=1;
   if(ioctlsocket(Socko,FIONBIO,&t))
   {
    FCEUD_PrintError("Winsock: Error setting socket to non-blocking mode!\n");
    return 0;
   }
  return 1;
}

BOOL CALLBACK BoogaDooga(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch(uMsg) {
   case WM_USER+1:
                if(WSAGETASYNCERROR(lParam))
                 concommand=1;
                else
                 concommand=2;
                break;
   case WM_USER:
                if(WSAGETSELECTEVENT(lParam)==FD_CONNECT)
                 {
                  if(WSAGETSELECTERROR(lParam))
                   concommand=1;
                  else
                   concommand=2;
                 }                
                break;
   case WM_INITDIALOG:
                if(netplay==1) SetDlgItemText(hwndDlg,100,(LPTSTR)"Waiting for a connection...");
                else SetDlgItemText(hwndDlg,100,(LPTSTR)"Attempting to establish a connection...");                                 
                break;
   case WM_CLOSE:
   case WM_QUIT: goto gornk;
   case WM_COMMAND:
                if(!(wParam>>16))
                switch(wParam&0xFFFF)
                {
                  case 1:
                        gornk:
                        abortnetplay=1;
                        EndDialog(hwndDlg,0);
                        break;
               }
              }
  return 0;

}
static void CloseNSDialog(void)
{
 if(hwndns)
  {
   SendMessage(hwndns,WM_COMMAND,1,0);
   hwndns=0;
  }
}
void CreateStatusDialog(void)
{
 hwndns=CreateDialog(fceu_hInstance,"NETSTAT",hAppWnd,BoogaDooga);
}

#define PORTNUM         0xFCE          // Port number

SOCKET ServerSock = INVALID_SOCKET;   // Socket bound to the server

int FCEUD_NetworkConnect(void)
{
  SOCKADDR_IN local_sin,accept_sin;
  SOCKADDR_IN destination_sin;        // Server socket address
  WSADATA WSAData;                    // Contains details of the 
                                      // Winsocket implementation

  // Initialize Winsocket.
 FCEUD_NetworkClose();
 if (WSAStartup (MAKEWORD(1,1), &WSAData) != 0)
 {   
   FCEUD_PrintError("Winsock: Error initializing winsock.");
   return 0;
 }
 wsainit=1;
 if(netplay==2)
 {
  char phostentb[MAXGETHOSTSTRUCT];

  // Create a TCP/IP socket that is bound to the server.
  if ((ServerSock = socket (AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)
    {FCEUD_PrintError("Winsock: Couldn't create TCP/IP socket.");return 0;}

  // Fill out the server socket's address information.
  destination_sin.sin_family = AF_INET;

  CreateStatusDialog();

  // Retrieve the host information corresponding to the host name.
  {
   concommand=0;
   if(!WSAAsyncGetHostByName(hwndns,WM_USER+1,(const char *)netplayhost,phostentb,MAXGETHOSTSTRUCT))
   {
    FCEUD_PrintError("Winsock: Error getting host network information.");    
    FCEUD_NetworkClose();
   }
   else
   {
     nc2:
     BlockingCheck();
     if(concommand==2) goto ncend;
     if(abortnetplay) goto clok1;
     if(concommand!=1) goto nc2;
     else
     {      
      FCEUD_PrintError("Winsock: Error getting host network information.");
      clok1:
      FCEUD_NetworkClose();
      return 0;
     }
   }
  }

  ncend:
  concommand=0;

  memcpy ((char FAR *)&(destination_sin.sin_addr),
          ((PHOSTENT)phostentb)->h_addr, 
          ((PHOSTENT)phostentb)->h_length);
  destination_sin.sin_port = htons (PORTNUM);  
  if(WSAAsyncSelect(ServerSock,hwndns,WM_USER,FD_CONNECT|FD_CLOSE)==SOCKET_ERROR)
   {
   FCEUD_NetworkClose();
   FCEUD_PrintError("Winsock: Error setting event notification on socket.");
   return 0;
   }
  if(!SetBlockingSock(ServerSock))
   {
   FCEUD_NetworkClose();
   return 0;
   }
  if (connect (ServerSock,
               (PSOCKADDR) &destination_sin, 
               sizeof (destination_sin)) == SOCKET_ERROR) 
  {
    if(WSAGetLastError()==WSAEWOULDBLOCK)
    {
     bc1:
     BlockingCheck();
     if(concommand==2) goto bc1end;
     if(abortnetplay) goto clok1;
     if(concommand!=1) goto bc1;
     else
     {
      FCEUD_PrintError("Winsock: Error connecting to remote host.");
      FCEUD_NetworkClose();
      return 0;
     }
    }
  }
  bc1end:
  concommand=0;
  if(WSAAsyncSelect(ServerSock,hAppWnd,WM_USER,0)==SOCKET_ERROR)
   {
    FCEUD_PrintError("Winsock: Error setting event notification on socket.");
    FCEUD_NetworkClose();
    return 0;
   }
 }
 else
 {
  SOCKET WinSock=INVALID_SOCKET;

  int accept_sin_len;

  if ((WinSock = socket (AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET)
    return 0;
  local_sin.sin_family=AF_INET;
  local_sin.sin_port=htons(PORTNUM);
  local_sin.sin_addr.s_addr=htonl(INADDR_ANY);
  if(bind(WinSock,(struct sockaddr *)&local_sin,sizeof(local_sin))==SOCKET_ERROR)
  {
   FCEUD_PrintError("Winsock: Error binding to socket.");
   closesocket(ServerSock);
   return 0;
  }

  if(listen(WinSock,1)==SOCKET_ERROR)
  {
   FCEUD_PrintError("Winsock: Error listening on socket.");
   closesocket(WinSock);
   return 0;
  }

  accept_sin_len=sizeof(accept_sin);
  CreateStatusDialog();

  if(!SetBlockingSock(WinSock))
  {
   closesocket(WinSock);
   FCEUD_NetworkClose();
   return 0;
  }
  bc2:
  ServerSock=accept(WinSock,(struct sockaddr*) &accept_sin,(int *)&accept_sin_len);
  if(ServerSock==INVALID_SOCKET)
   {
    if(WSAGetLastError()==WSAEWOULDBLOCK)
    {
     BlockingCheck();
     if(!abortnetplay) goto bc2;
     goto clok1;
    }
    FCEUD_PrintError("Winsock: Error accepting connection.");
    closesocket(WinSock);
    CloseNSDialog();
    return 0;
   }
   closesocket(WinSock);
   if(!SetBlockingSock(ServerSock))
    {
     FCEUD_NetworkClose();
     return 0;
    }
 }
  CloseNSDialog();
  return 1;
}


void FCEUD_NetworkClose(void)
{
  abortnetplay=concommand=0;
  CloseNSDialog();
  if(ServerSock!=INVALID_SOCKET)
  {
   // Disable sending on ServerSock.
   shutdown (ServerSock, 0x01);

   // Disable receiving on ServerSock.
   shutdown (ServerSock, 0x00);

   // Close the socket.
   closesocket (ServerSock);
   ServerSock=INVALID_SOCKET;
  }
  if(wsainit)
  {
   WSACleanup();
   wsainit=0;
  }
}


int FCEUD_NetworkSendByte(unsigned char *Value)
{
        while(send(ServerSock,Value,1,0)==SOCKET_ERROR)
        {
         if(WSAGetLastError()==WSAEWOULDBLOCK)
          continue;
         return(0);
        }
        return 1;
}

int FCEUD_NetworkRecvByte(unsigned char *Value)
{
        while(recv(ServerSock,Value,1,0)==SOCKET_ERROR)
        {
         if(WSAGetLastError()==WSAEWOULDBLOCK)
          continue;
         return(0);
        }
        return 1;
}

BOOL CALLBACK NetConCallB(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch(uMsg) {
   case WM_INITDIALOG:                
                if(netplay!=-1)
                 {
                 CheckRadioButton(hwndDlg,103,105,netplay?103:105);
                 if(netplayhost[0])
                  SetDlgItemText(hwndDlg,104,netplayhost);
                 }
                break;
   case WM_CLOSE:
   case WM_QUIT: goto gornk;
   case WM_COMMAND:
                if(!(wParam>>16))
                switch(wParam&0xFFFF)
                {
                 case 1:
                        gornk:

                        if(IsDlgButtonChecked(hwndDlg,103)==BST_CHECKED)
                         {
                         if(GetDlgItemText(hwndDlg,104,netplayhost,255))
                          {
                           netplayhost[255]=0;
                           netplay=2;
                          }
                          else
                           netplay=0;
                         }
                        else if(IsDlgButtonChecked(hwndDlg,105)==BST_CHECKED)
                         {
                         BOOL doh;
                         netskip=GetDlgItemInt(hwndDlg,104,&doh,0);
                         if(!doh) netplay=0;
                         else netplay=1;
                         }
                        else                        
                         netplay=0;
                        EndDialog(hwndDlg,0);
                        break;
               }
              }
  return 0;
}


static void ConfigNetplay(void)
{
 DialogBox(fceu_hInstance,"NETPLAYCONFIG",hAppWnd,NetConCallB);
 FCEUI_SetNetworkPlay(netplay,netskip);
}

