#include "mapinc.h"

static void FP_FASTAPASS(1) BandaiIRQHook(int a)
{
  if(IRQa)
  {
   IRQCount-=a;
   if(IRQCount<=0)
   {
    M6502_IRQBegin(FCEU_IQEXT);
    //printf("IRQ: %d, %d\n",scanline,timestamp);
    IRQa=0;
    IRQCount=0;
   }
  }
}

// Famicom jump 2:
// 0-7: Lower bit of data selects which 256KB PRG block is in use(?)

static DECLFW(Mapper16_write)
{
	A&=0xF;
        //if(A>=0xA && A<=0xC) printf("$%04x:$%02x, %d, %d\n",A,V,scanline,timestamp);
        if(A<=0x7) VROM_BANK1(A<<10,V);
        else if(A==0x8) ROM_BANK16(0x8000,V);
	else switch(A) {
	 case 0x9: switch(V&3) {
       	            case 0x00:MIRROR_SET2(1);break;
                    case 0x01:MIRROR_SET2(0);break;
                    case 0x02:onemir(0);break;
                    case 0x03:onemir(1);break;
                   }
                   break;
         case 0xA:M6502_IRQEnd(FCEU_IQEXT);
  		  IRQa=V&1;break;
         case 0xB:IRQCount&=0xFF00;
		  IRQCount|=V;
 		  break;
         case 0xC:IRQCount&=0xFF;
 		  IRQCount|=V<<8;
		  break;
         case 0xD: break;/* Serial EEPROM control port */
        }
}

void Mapper16_init(void)
{
 MapIRQHook=BandaiIRQHook;
 SetWriteHandler(0x6000,0xFFFF,Mapper16_write);
}

